<script lang="ts" setup>
import promotion from '@/services/promotion'
import { usePromotionStore } from '@/stores/Promotion'
import { computed, ref } from 'vue'

const promotionStore = usePromotionStore()
// Reusable validation function
</script>
<template>
  <v-col cols="12">{{ 'ชนิดของ Promotion' }} </v-col>
  <v-col cols="12"
    ><v-select
      label="Promotion type"
      :items="promotionStore.promotionItemtype"
      v-model="promotionStore.promotionItemselectedChoice"
    ></v-select
  ></v-col>

  <v-col cols="12" v-if="promotionStore.shouldRenderProductIdtextfield">
    <!-- ใช้ type = number เพื่อที่จะ input เป็น number only -->
    <v-text-field
      :rules="[
        (v) => {
          if (v === null) {
            return 'Field is required'
          } else if (v <= 0) {
            return 'Please input more than zero'
          } else {
            return true // Validation passes
          }
        }
      ]"
      label="Product Id"
      v-model="promotionStore.editedPromotion.promotionItems![0].productId"
      type="number"
    ></v-text-field>
  </v-col>
  <!-- อะแห่ม ถ้าถามว่า v-else ต้องมีทำไม? คืองี้ครับ เวลาเซฟแล้วมันชอบค้าง ผมก็แก้ เลย ถ้าcomponet ไม่เปิด ให้ ค่าเป็น null ให้หมด -->
  <div v-else>
    {{ (promotionStore.editedPromotion.promotionItems![0].productId = null) }}
  </div>
  <v-col cols="6" v-if="promotionStore.shouldRenderConQuantityTextfield">
    <v-text-field
      :rules="[
        (v) => {
          if (v === null) {
            return 'Field is required'
          } else if (v < 0) {
            return 'Please input more than zero'
          } else {
            return true // Validation passes
          }
        }
      ]"
      label="ConditionQuantiy"
      v-model="promotionStore.editedPromotion.promotionItems![0].conditionQty"
      type="number"
    ></v-text-field>
  </v-col>
  <div v-else>
    {{ (promotionStore.editedPromotion.promotionItems![0].conditionQty = null) }}
  </div>
  <v-col cols="6" v-if="promotionStore.shouldRenderConPriceTextfield">
    <v-text-field
      :rules="[
        (v) => {
          if (v === null) {
            return 'Field is required'
          } else if (v < 0) {
            return 'Please input more than zero'
          } else {
            return true // Validation passes
          }
        }
      ]"
      label="ConditionPrice"
      v-model="promotionStore.editedPromotion.promotionItems![0].conditionPrice"
      type="number"
    ></v-text-field>
  </v-col>
  <div v-else>
    {{ (promotionStore.editedPromotion.promotionItems![0].conditionPrice = null) }}
  </div>
  <v-col cols="6" v-if="promotionStore.shouldRenderDisPriceTextfield">
    <v-text-field
      :rules="[
        (v) => {
          if (v === null) {
            return 'Field is required'
          } else if (v < 0) {
            return 'Please input more than zero'
          } else {
            return true // Validation passes
          }
        }
      ]"
      label="DiscountPrice"
      v-model="promotionStore.editedPromotion.promotionItems![0].discountPrice"
      type="number"
    ></v-text-field>
  </v-col>
  <div v-else>
    {{ (promotionStore.editedPromotion.promotionItems![0].discountPrice = null) }}
  </div>
  <v-col cols="6" v-if="promotionStore.shouldRenderDisPercentTextfield">
    <v-text-field
      :rules="[
        (v) => {
          if (v === null) {
            return 'Field is required'
          } else if (v < 0) {
            return 'Please input more than zero'
          } else {
            return true // Validation passes
          }
        }
      ]"
      label="DiscountPercent"
      v-model="promotionStore.editedPromotion.promotionItems![0].discountPercent"
      type="number"
    ></v-text-field>
  </v-col>
  <div v-else>
    {{ (promotionStore.editedPromotion.promotionItems![0].discountPercent = null) }}
  </div>
</template>
